/***********************************************************************/
/* Copyright (c) 1999-2005, The Rector and Board of Visitors of the    */
/* University of Virginia.                                             */
/* All rights reserved.                                                */
/*                                                                     */
/* This program is being made available under the terms of version 2.1 */
/* of theGNU Lesser General Public License ("LGPL") as published as of */
/* February, 1999 by the Free Software  Foundation; and subject to the */
/* restrictions of the LGPL, you are authorized to  modify and/or      */
/* redistribute it.                                                    */
/*                                                                     */
/* As stated in the LGPL, THIS PROGRAM IS BEING MADE AVAILABLE "AS IS",*/
/* AND WITHOUT A WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,    */
/* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF            */
/* MERCHANTABILITY AND  FITNESS FOR A PARTICULAR PURPOSE. FURTHER, YOU */
/* AGREE NOT TO HOLD THE COPYRIGHT  OWNER(S) LIABLE FOR DAMAGES,       */
/* INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES,*/
/* ARISING OUT OF THE USE OR INABILITY TO USE  THE PROGRAM.            */
/* See the GNU General Public License for more details.                */
/*                                                                     */
/* You should have received a copy of version 2.1 of the GNU General   */
/* Public License along with this program; if not, you may obtain a    */
/* copy  from the Free Software Foundation website at the following URL*/
/* address (link  active as of September 1, 2005):                     */
/* http://www.fsf.org/licensing/licenses/lgpl.html; or that failing,   */
/* you can request a copy from Free Software Foundation,  Inc., 51     */
/* Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.                */
/*                                                                     */
/* This program is part of the HyperCast software distribution. To     */
/* learn more about HyperCast, please visit the website at             */
/* http://www.hypercast.org.                                           */
/***********************************************************************/


 /* 
  * @author HyperCast Team
  * July 2002
  */

package lotos;

import lotos.*; 
/**
 * The interface for MAC layer protocol
 * 
 * @revised Guangyu Dong, Jan 6, 2004
 */
public interface MACInterface
{
	/* 
	 * Send a message to MAC layer
	 */
	boolean sendMsg(SimEventMsg msg);
	
	/* 
	 * Used to tell the MAC layer a MAC in transmission range
	 * is going to send out a packet
	 * @param ms_start_time the start time of sending in MS
	 * @param ms_end_time the end time of sending in MS 
	 */
	void recordMessage(long ms_start_time, long ms_end_time);
	/* 
	 * Used to tell the MAC layer a MAC in sensing range
	 * is going to send out a packet
	 * @param ms_start_time the start time of sending in MS
	 * @param ms_end_time the end time of sending in MS 
	 */
	void senseMessage(long ms_start_time, long ms_end_time);
	
	/*
	 * go forward a step and update the status
	 */
	void MACStep();
	/*
	 * handle mac event
	 */
	void handleMACTimer(SimEventMAC mac_event);
	
	/*
	 * Initiating
	 */
	void MACInit();
	/*
	 * @return size of mac layer header in Bytes
	 */
	int getHeaderSize();
	
}
