/***********************************************************************/
/* Copyright (c) 1999-2005, The Rector and Board of Visitors of the    */
/* University of Virginia.                                             */
/* All rights reserved.                                                */
/*                                                                     */
/* This program is being made available under the terms of version 2.1 */
/* of theGNU Lesser General Public License ("LGPL") as published as of */
/* February, 1999 by the Free Software  Foundation; and subject to the */
/* restrictions of the LGPL, you are authorized to  modify and/or      */
/* redistribute it.                                                    */
/*                                                                     */
/* As stated in the LGPL, THIS PROGRAM IS BEING MADE AVAILABLE "AS IS",*/
/* AND WITHOUT A WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,    */
/* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF            */
/* MERCHANTABILITY AND  FITNESS FOR A PARTICULAR PURPOSE. FURTHER, YOU */
/* AGREE NOT TO HOLD THE COPYRIGHT  OWNER(S) LIABLE FOR DAMAGES,       */
/* INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES,*/
/* ARISING OUT OF THE USE OR INABILITY TO USE  THE PROGRAM.            */
/* See the GNU General Public License for more details.                */
/*                                                                     */
/* You should have received a copy of version 2.1 of the GNU General   */
/* Public License along with this program; if not, you may obtain a    */
/* copy  from the Free Software Foundation website at the following URL*/
/* address (link  active as of September 1, 2005):                     */
/* http://www.fsf.org/licensing/licenses/lgpl.html; or that failing,   */
/* you can request a copy from Free Software Foundation,  Inc., 51     */
/* Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.                */
/*                                                                     */
/* This program is part of the HyperCast software distribution. To     */
/* learn more about HyperCast, please visit the website at             */
/* http://www.hypercast.org.                                           */
/***********************************************************************/


 /* 
  * @author HyperCast Team
  * 
  */

package lotos;

import lotos.*; 
class MobiReflectiveLinear implements MobilityInterface
{
	private boolean MobilityEnabled;
	static float minX = 0;
	static float maxX = 800;
	static float minY = 0;
	static float maxY = 800;
	static float minZ = 0;
	static float maxZ = 800;
	private float speedX;
	private float speedY;
	private float speedZ;
	private float speed;
	
	private float prevTime = -1;
	
	public String toString(){ return "Linear Motion";}
	
	MobiReflectiveLinear()
	{
		init();
	}

	MobiReflectiveLinear(float paramSpeed)
	{
		init();
		speed = paramSpeed;
		speedX = (float)(speed*2*(Math.random()-0.5));
		speedY = (float)(speed*2*(Math.random()-0.5));
		speedZ = (float)(speed*2*(Math.random()-0.5));
	}

	void init()
	{
		speed = 2;
		speedX = (float)(speed*2*(Math.random()-0.5));
		speedY = (float)(speed*2*(Math.random()-0.5));
		speedZ = (float)(speed*2*(Math.random()-0.5));
		
		MobilityEnabled = true;
	}

	public void mobilityEnable()
	{
		MobilityEnabled = true;
	}

	public void mobilityDisable()
	{
		MobilityEnabled = false;
	}

	public Position move(float now, Position prev)
	{
		Position next;
		float x;	float y;	float z;
		
		float timeDifference = now - prevTime;
		
		if(MobilityEnabled && prevTime>=0)
		{
			x = prev.getX();
			y = prev.getY();
			z = prev.getZ();
			if(x < minX) x = minX;
			if(x > maxX) x = maxX;
			if(y < minY) y = minY;
			if(y > maxY) y = maxY;
			if(z < minZ) z = minZ;
			if(z > maxZ) z = maxZ;
			x += speedX * timeDifference;
			y += speedY * timeDifference;
			z += speedZ * timeDifference;
			if(x < minX) { x = minX + (minX - x); speedX = -speedX; }
			if(x > maxX) { x = maxX + (maxX - x); speedX = -speedX; }
			if(y < minY) { y = minY + (minY - y); speedY = -speedY; }
			if(y > maxY) { y = maxX + (maxY - y); speedY = -speedY; }
			if(z < minZ) { z = minZ + (minZ - z); speedZ = -speedZ; }
			if(z > maxZ) { z = maxZ + (maxZ - z); speedZ = -speedZ; }
			next = new Position(x,y,z);
		}
		else
		{
			next = new Position(prev);
		}
		
		prevTime = now;
		
		return next;
	}
}

