/***********************************************************************/
/* Copyright (c) 1999-2005, The Rector and Board of Visitors of the    */
/* University of Virginia.                                             */
/* All rights reserved.                                                */
/*                                                                     */
/* This program is being made available under the terms of version 2.1 */
/* of theGNU Lesser General Public License ("LGPL") as published as of */
/* February, 1999 by the Free Software  Foundation; and subject to the */
/* restrictions of the LGPL, you are authorized to  modify and/or      */
/* redistribute it.                                                    */
/*                                                                     */
/* As stated in the LGPL, THIS PROGRAM IS BEING MADE AVAILABLE "AS IS",*/
/* AND WITHOUT A WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,    */
/* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF            */
/* MERCHANTABILITY AND  FITNESS FOR A PARTICULAR PURPOSE. FURTHER, YOU */
/* AGREE NOT TO HOLD THE COPYRIGHT  OWNER(S) LIABLE FOR DAMAGES,       */
/* INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES,*/
/* ARISING OUT OF THE USE OR INABILITY TO USE  THE PROGRAM.            */
/* See the GNU General Public License for more details.                */
/*                                                                     */
/* You should have received a copy of version 2.1 of the GNU General   */
/* Public License along with this program; if not, you may obtain a    */
/* copy  from the Free Software Foundation website at the following URL*/
/* address (link  active as of September 1, 2005):                     */
/* http://www.fsf.org/licensing/licenses/lgpl.html; or that failing,   */
/* you can request a copy from Free Software Foundation,  Inc., 51     */
/* Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.                */
/*                                                                     */
/* This program is part of the HyperCast software distribution. To     */
/* learn more about HyperCast, please visit the website at             */
/* http://www.hypercast.org.                                           */
/***********************************************************************/


 /* 
  * @author HyperCast Team, July 2002
  * 
  */
package lotos;

import lotos.*; 
/**
 * This class implements the simulation event
 */
class SimEvent
{
    /** time of the event */
    /** changed to "long" by Guangyu to get precise microsecond level time */
    /** 1000000 = 1sec */
    long time;
    //float time;
    final static float TIME_PER_SEC=1000000f;
    
    /** sender of the event */
    OverlayNode sender;
    /** recipient of the event */
    OverlayNode recipient;
    /** type of the message */
    int event_type;

    final static int MESSAGE_EVENT = 1;
    final static int PROTOCOL_TIMER_EVENT = 2;
    final static int MAC_TIMER_EVENT = 3;
	
	public SimEvent(long t, OverlayNode asender, OverlayNode onode, int et)
    {
        setMSTime(t);
        recipient = onode;
        sender = asender;
        event_type = et;
    }
	
    public SimEvent(float t, OverlayNode asender, OverlayNode onode, int et)
    {
        setTime(t);
        recipient = onode;
        sender = asender;
        event_type = et;
    }
	public long getMSTime(){
		return time;
	}
    public float getTime()
    {
    	/* get float time*/
        return (float)time/TIME_PER_SEC;
    }
    
    /* set event time with microseconds */
	public void setMSTime(long t){
		time=t;
	}
	
	/* set event time with real seconds */
    public void setTime(float t)
    {
        time = (long)(t*TIME_PER_SEC);
    }

    public OverlayNode getRecipient()
    {
        return recipient;
    }

    public OverlayNode getSender()
    {
        return sender;
    }

    public void setRecipient(OverlayNode onode ){
        recipient = onode;
    }

    public void setSender(OverlayNode onode ){
        sender = onode;
    }

    public int eventType()
    {
        return event_type;
    }
    
    
}
