/***********************************************************************/
/* Copyright (c) 1999-2005, The Rector and Board of Visitors of the    */
/* University of Virginia.                                             */
/* All rights reserved.                                                */
/*                                                                     */
/* This program is being made available under the terms of version 2.1 */
/* of theGNU Lesser General Public License ("LGPL") as published as of */
/* February, 1999 by the Free Software  Foundation; and subject to the */
/* restrictions of the LGPL, you are authorized to  modify and/or      */
/* redistribute it.                                                    */
/*                                                                     */
/* As stated in the LGPL, THIS PROGRAM IS BEING MADE AVAILABLE "AS IS",*/
/* AND WITHOUT A WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,    */
/* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF            */
/* MERCHANTABILITY AND  FITNESS FOR A PARTICULAR PURPOSE. FURTHER, YOU */
/* AGREE NOT TO HOLD THE COPYRIGHT  OWNER(S) LIABLE FOR DAMAGES,       */
/* INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES,*/
/* ARISING OUT OF THE USE OR INABILITY TO USE  THE PROGRAM.            */
/* See the GNU General Public License for more details.                */
/*                                                                     */
/* You should have received a copy of version 2.1 of the GNU General   */
/* Public License along with this program; if not, you may obtain a    */
/* copy  from the Free Software Foundation website at the following URL*/
/* address (link  active as of September 1, 2005):                     */
/* http://www.fsf.org/licensing/licenses/lgpl.html; or that failing,   */
/* you can request a copy from Free Software Foundation,  Inc., 51     */
/* Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.                */
/*                                                                     */
/* This program is part of the HyperCast software distribution. To     */
/* learn more about HyperCast, please visit the website at             */
/* http://www.hypercast.org.                                           */
/***********************************************************************/

 /* 
  * @author HyperCast Team, 2002 
  * 
  */
package lotos;

import lotos.*; 
import java.awt.*;

/**
 * physical address of a node
 */

class XYAddress
{
    float x, y;

/** added by Guangyu to support mobility */
public XYAddress(float x2, float y2)
    {
        x = x2;
        y = y2;
    }


public XYAddress(int x2, int y2)
    {
        x = x2;
        y = y2;
    }

public XYAddress(Point p)
    {
        x = p.x;
        y = p.y;
    }

    /**
     * constructor in "xx,yy" format
     */
public XYAddress(String s) {
    int word_end = s.indexOf(',');
    x = Float.valueOf(s.substring(0,word_end)).intValue();
    y = Float.valueOf(s.substring(word_end+1,s.length())).intValue();
}

public final String toString()
    {
        StringBuffer s = new StringBuffer();
        s.append(x);
        s.append(",");
        s.append(y);
        return s.toString();
    }

public int getX()
    {
        return (int)x;
    }

public int getY()
    {
        return (int)y;
    }
    
/** added by Guangyu to support mobility */
public float getXF()
	{
		return x;
	}
public float getYF()
    {
        return y;
    }	
	

public boolean equals(XYAddress a)
    {
            return a.getX() == x && a.getY() == y;
    }

public float distanceTo(XYAddress addr)
    {
        int dx = getX() - addr.getX();
        int dy = getY() - addr.getY();

        float d = (float) Math.sqrt(dx*dx + dy*dy);
	return d;
    }

public Point toPoint()
    {
        return new Point(getX(), getY());
    }

}
