/***********************************************************************/
/* Copyright (c) 1999-2005, The Rector and Board of Visitors of the    */
/* University of Virginia.                                             */
/* All rights reserved.                                                */
/*                                                                     */
/* This program is being made available under the terms of version 2.1 */
/* of theGNU Lesser General Public License ("LGPL") as published as of */
/* February, 1999 by the Free Software  Foundation; and subject to the */
/* restrictions of the LGPL, you are authorized to  modify and/or      */
/* redistribute it.                                                    */
/*                                                                     */
/* As stated in the LGPL, THIS PROGRAM IS BEING MADE AVAILABLE "AS IS",*/
/* AND WITHOUT A WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,    */
/* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF            */
/* MERCHANTABILITY AND  FITNESS FOR A PARTICULAR PURPOSE. FURTHER, YOU */
/* AGREE NOT TO HOLD THE COPYRIGHT  OWNER(S) LIABLE FOR DAMAGES,       */
/* INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES,*/
/* ARISING OUT OF THE USE OR INABILITY TO USE  THE PROGRAM.            */
/* See the GNU General Public License for more details.                */
/*                                                                     */
/* You should have received a copy of version 2.1 of the GNU General   */
/* Public License along with this program; if not, you may obtain a    */
/* copy  from the Free Software Foundation website at the following URL*/
/* address (link  active as of September 1, 2005):                     */
/* http://www.fsf.org/licensing/licenses/lgpl.html; or that failing,   */
/* you can request a copy from Free Software Foundation,  Inc., 51     */
/* Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.                */
/*                                                                     */
/* This program is part of the HyperCast software distribution. To     */
/* learn more about HyperCast, please visit the website at             */
/* http://www.hypercast.org.                                           */
/***********************************************************************/


 /* 
  * @author HyperCast Team, 2002 
  * 
  */
package lotos;

import lotos.*; 
import java.awt.*;
import java.awt.event.*;
import java.applet.*;


/**
 * This class implements the about dialog shown at GUI
 *
 */
class aboutDialog extends Frame implements ActionListener{

    /** the tilte of the dialog */
    TextField head;

    /** Hypercast icon */
    Image img;

    /** okay button */
    Button button;

    /**
     * Constructor
     * @param isApplet whether the frame runs as an applet or not
     * @param gui the reference of the applet
     */
    aboutDialog( boolean isApplet, Applet gui ) {
        super("about");
        if( isApplet )
            setIconImage( gui.getImage( gui.getDocumentBase(), "hcast.gif" ) );
        else
            setIconImage( getToolkit().createImage("mng.gif") );

        head = new TextField("Lotos Simulator, MNG Group, UVA)");
        head.setEditable(false);
        add(BorderLayout.NORTH, head );

        if( isApplet ) {
            img = gui.getImage( gui.getDocumentBase(), "hypercast.jpg");
        }else{
            Toolkit tk = getToolkit();
            img = tk.createImage("hypercast.jpg");
        }
        add(BorderLayout.CENTER, new aboutCanvas(img) );

        button = new Button("close");
        button.addActionListener(this);
        Panel tmpPanel = new Panel();
        tmpPanel.add( new Panel() );
        tmpPanel.add( button );
        tmpPanel.add( new Panel() );
        add(BorderLayout.SOUTH, tmpPanel );

        setSize( 250, 250 );
        setVisible(true);
    }

    /**
     * handling of the okay button pushed event
     */
    public void actionPerformed( ActionEvent ae ){
        if( ae.getSource() == button ){
            setVisible(false);
        }
    }

    public static void main(String argv[]) {
        aboutDialog dia = new aboutDialog( false, null );
    }
}

/**
 * This class is used to display an image in its drawing area
 * Here, it is used to display the logo of MNG group
 */
class aboutCanvas extends Canvas {

    Image img;
    aboutCanvas( Image image ) { img = image;}

    public void paint( Graphics g ){
        g.drawImage(img, 0, 0, this.getSize().width, this.getSize().height, this);
    }
}
