/***********************************************************************/
/* Copyright (c) 1999-2005, The Rector and Board of Visitors of the    */
/* University of Virginia.                                             */
/* All rights reserved.                                                */
/*                                                                     */
/* This program is being made available under the terms of version 2.1 */
/* of theGNU Lesser General Public License ("LGPL") as published as of */
/* February, 1999 by the Free Software  Foundation; and subject to the */
/* restrictions of the LGPL, you are authorized to  modify and/or      */
/* redistribute it.                                                    */
/*                                                                     */
/* As stated in the LGPL, THIS PROGRAM IS BEING MADE AVAILABLE "AS IS",*/
/* AND WITHOUT A WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,    */
/* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF            */
/* MERCHANTABILITY AND  FITNESS FOR A PARTICULAR PURPOSE. FURTHER, YOU */
/* AGREE NOT TO HOLD THE COPYRIGHT  OWNER(S) LIABLE FOR DAMAGES,       */
/* INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES,*/
/* ARISING OUT OF THE USE OR INABILITY TO USE  THE PROGRAM.            */
/* See the GNU General Public License for more details.                */
/*                                                                     */
/* You should have received a copy of version 2.1 of the GNU General   */
/* Public License along with this program; if not, you may obtain a    */
/* copy  from the Free Software Foundation website at the following URL*/
/* address (link  active as of September 1, 2005):                     */
/* http://www.fsf.org/licensing/licenses/lgpl.html; or that failing,   */
/* you can request a copy from Free Software Foundation,  Inc., 51     */
/* Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.                */
/*                                                                     */
/* This program is part of the HyperCast software distribution. To     */
/* learn more about HyperCast, please visit the website at             */
/* http://www.hypercast.org.                                           */
/***********************************************************************/


 /* 
  * @author HyperCast Team, 2002 
  * 
  */
package lotos;

import lotos.*; 
import java.awt.*;
import java.awt.event.*;
import java.applet.*;

/**
 * the dialog that reports the statistics
 */
class reportDialog extends Frame implements ActionListener{

    /** displays the statistics */
    TextArea text;
    /** okay button */
    Button button;

    /** constructor
     *  @param s the statistics report in a string format
     *  @param isApplet whether the application is running as an applet or
     *  a standalone application
     *  @param gui a reference to the applet
     */
    reportDialog( String s, boolean isApplet, Applet gui ) {
        super("statistic report");
        if( isApplet )
            setIconImage( gui.getImage( gui.getDocumentBase(), "hcast.gif" ) );
        else
            setIconImage( getToolkit().createImage("mng.gif") );

        text = new TextArea( s, 9, 25, TextArea.SCROLLBARS_NONE  );
        text.setEditable(false);
        add(BorderLayout.CENTER, text );

        //add(BorderLayout.CENTER, new aboutCanvas(img) );

        button = new Button("close");
        button.addActionListener(this);
        Panel tmpPanel = new Panel();
        tmpPanel.add( new Panel() );
        tmpPanel.add( button );
        tmpPanel.add( new Panel() );
        add(BorderLayout.SOUTH, tmpPanel );

        setSize( 250, 250 );
        setVisible(true);
    }

    public void actionPerformed( ActionEvent ae ){
        if( ae.getSource() == button ){
            setVisible(false);
        }
    }

    public static void main(String argv[]) {
        reportDialog report = new reportDialog( "aaa\nbbb\nccc\n", false, null );
    }
}

